hdu 4568 Hunter 最短路+dp

Hunter

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 2014    Accepted Submission(s): 615


Problem Description
  One day, a hunter named James went to a mysterious area to find the treasures. James wanted to research the area and brought all treasures that he could.
  The area can be represented as a N*M rectangle. Any points of the rectangle is a number means the cost of research it,-1 means James can't cross it, James can start at any place out of the rectangle, and explore point next by next. He will move in the rectangle and bring out all treasures he can take. Of course, he will end at any border to go out of rectangle(James will research every point at anytime he cross because he can't remember whether the point are researched or not).
  Now give you a map of the area, you must calculate the least cost that James bring out all treasures he can take(one point up to only one treasure).Also, if nothing James can get, please output 0.
 
Input
  The input consists of T test cases. The number of test cases T is given in the first line of the input. Each test case begins with a line containing 2 integers N M , (1<=N,M<=200), that represents the rectangle. Each of the following N lines contains M numbers(0~9),represent the cost of each point. Next is K(1<=K<=13),and next K lines, each line contains 2 integers x y means the position of the treasures, x means row and start from 0, y means column start from 0 too.
 
Output
  For each test case, you should output only a number means the minimum cost.
 
Sample Input
2
3 3
3 2 3
5 4 3
1 4 2
1
1 1
 
 
3 3
3 2 3
5 4 3
1 4 2
2
1 1
2 2
 
Sample Output
8 11
/*
hdu 4568 Hunter 最短路+dp

problem:
给你一个n*m的地图,每走一个格子会有一定的花费.求拿到所有宝藏的最小花费

solve:
想了很久感觉没什么思路TAT
后来看别人题解可以把这个问题转换一下.
因为总共只有13个宝藏,所以我们可以处理出每个宝藏之间的最短路(即最小花费).
在弄出每个宝藏到边界的最小距离. 那么就可以看成13个点的图.找出遍历所有点的最小花费
而13个点的状态可以用二进制保存,所以dp就好.

hhh-2016-08-26 21:43:38
*/
#pragma comment(linker,"/STACK:124000000,124000000")
#include <algorithm>
#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <vector>
#include <math.h>
#include <queue>
#include <map>
#define lson  i<<1
#define rson  i<<1|1
#define ll long long
#define clr(a,b) memset(a,b,sizeof(a))
#define scanfi(a) scanf("%d",&a)
#define scanfl(a) scanf("%I64d",&a)
#define key_val ch[ch[root][1]][0]
#define inf 0x3f3f3f3f
using namespace std;
const ll mod = 1e9+7;
const int maxn = 220;

struct NODE
{
    int id,len;
    NODE() {}
    NODE(int i,int d):id(i),len(d) {}
    bool operator <(const NODE &a) const
    {
        return len >  a.len;
    }
};
int n,m;
int dx[4]= {-1,1,0,0};
int dy[4]= {0,0,-1,1};
int from[maxn][maxn];
int vis[maxn*maxn],tmap[maxn][maxn],tp[maxn][maxn],out[maxn];
int pos[maxn*maxn],dis[maxn*maxn];
void dij(int st,int fp)
{
    memset(vis,0,sizeof(vis));
    memset(dis,inf,sizeof(dis));
    priority_queue<NODE> q;
    q.push(NODE(st,0));
    dis[st] = 0;
    while(!q.empty())
    {
        NODE t = q.top();
        q.pop();
        int cur = t.id;
        if(vis[cur]) continue;
        vis[cur] = 1;
        int x = cur/m,y = cur%m;
        if(tp[x][y] != -1)
            from[fp][tp[x][y]] = dis[cur];
        if(x == n-1 || x == 0 || y == m-1 || y == 0)
        {
            out[fp]= min(out[fp],dis[cur]);
        }
        for(int i = 0; i < 4; i++)
        {
            int tx = x + dx[i];
            int ty = y + dy[i];
            if(tmap[tx][ty] == -1) continue;
            if(tx >= n || tx < 0 || ty >= m || ty < 0)
                continue;
            if(dis[tx*m + ty] > dis[cur] + tmap[tx][ty])
            {
                dis[tx*m + ty] = dis[cur] + tmap[tx][ty];
                q.push(NODE(tx*m + ty, dis[tx*m + ty] ));
            }
        }
    }
    return ;
}

int dp[20][1 << 14];
void init()
{
    memset(from,0,sizeof(from));
    memset(out,inf,sizeof(out));
    memset(tp,-1,sizeof(tp));
    memset(dp,inf,sizeof(dp));
}


int main()
{
//    freopen("in.txt","r",stdin);
    int T,x,y;
    scanf("%d",&T);
    while(T--)
    {
        init();
        scanfi(n),scanfi(m);
        for(int i = 0; i < n; i++)
        {
            for(int j = 0; j < m; j++)
                scanfi(tmap[i][j]);
        }
        int q;
        scanfi(q);
        for(int i = 0; i < q; i++)
        {
            scanfi(x),scanfi(y);
            tp[x][y] = i;
            pos[i] = x*m + y;
        }
        for(int i = 0; i < q; i++)
        {
            from[i][i] = 0;
            dij(pos[i],i);
        }
        for(int i = 0; i < q; i++)
        {
            dp[i][1 << i] = out[i]+tmap[pos[i]/m][pos[i]%m];
        }
//        for(int i = 0;i < q;i++)
//        {
//            cout << "i"<<i<<":" <<out[i] <<endl;
//            for(int j = i;j < q;j++)
//                cout << i <<"----"<<j<<" :" <<from[i][j]<<endl;
//        }
//        cout <<endl;
        for(int i = 0; i < (1 << q); i++)
        {
            for(int j = 0; j < q; j++)
            {
                if( ((1 << j) & i) && i != (1 << j))
                {
                    for(int k = 0; k < q; k++)
                    {
                        if( (i & (1 << k)) && j != k && i != (1<< k))
                            dp[j][i] = min(dp[k][i-(1 << j)]+from[k][j],dp[j][i]);
                    }
                }
            }
        }
        int ans = inf;
        for(int i = 0; i < q; i++)
        {
            ans = min(ans,dp[i][(1<<q)-1] + out[i]);
//            cout << ans <<endl;
        }
        printf("%d
",ans);
    }
    return 0;
}

  

原文地址:https://www.cnblogs.com/Przz/p/5812369.html